import pyadchpp as adchpp
import Hub
import sys, os, shlex, re, time
import json
import autil
import SettingManager, CommandManager, UserManager
import threading

sys.path.append(os.path.abspath('../'))

bans = {}
bansLock = threading.RLock()

nicks = {}
cids = {}
ips = {}
nicksre = {}
msgsre = {}
muted = {}

bans['nicks'] = nicks
bans['cids'] = cids
bans['ips'] = ips
bans['nicksre'] = nicksre
bans['msgre'] = msgsre
bans['muted'] = muted

bansFile = 'bans.txt'
fileLock = threading.RLock()

cmdINF = None
cmdMSG = None

reTime_or_inf = re.compile("\s(?:(?:([-+]?[0-9]*\.?[0-9]+(?:[eE][-+]?[0-9]+)?)?(?:w(?:eek(?:s)?)?))?(?:([-+]?[0-9]*\.?[0-9]+(?:[eE][-+]?[0-9]+)?)?(?:d(?:ay(?:s)?)?))?(?:([-+]?[0-9]*\.?[0-9]+(?:[eE][-+]?[0-9]+)?)?(?:h(?:our(?:s)?)?))?(?:([-+]?[0-9]*\.?[0-9]+(?:[eE][-+]?[0-9]+)?)?(?:m(?:in(?:ute(?:s)?)?)?))?(?:([-+]?[0-9]*\.?[0-9]+(?:[eE][-+]?[0-9]+)?)?(?:s(?:ec(?:ond(?:s)?)?)?))?)$|\s(inf?$)?$") #oh god

#float_at_end = re.compile("\s([-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?$)?$")
#inf_at_end = re.compile("\s(inf?$)?$")
#float_at_end_or_inf = re.compile("\s(([-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?$)|(inf?$))?$")

initiated = False

class Ban(dict):
    def __init__(self, level = 0, reason = "", expires = 0, reexpires = 0):
        self['level'] = level
        self['reason'] = reason
        self['expires'] = expires
        self['reexpires'] = reexpires
        
    level = property(lambda self: self['level'], (lambda self,x: self.__setitem__('level', x)))
    reason = property(lambda self: self['reason'], (lambda self,x: self.__setitem__('reason', x)))
    expires = property(lambda self: self['expires'], (lambda self,x: self.__setitem__('expires', x)))
    reexpires = property(lambda self: self['reexpires'], (lambda self,x: self.__setitem__('reexpires', x)))

def initModule():
    global bans, nicks, cids, ips, nicksre, msgsre, muted, cmdINF, cmdMSG, initiated
    fileLock.acquire()
    bansLock.acquire()
    read_bans = autil.parseJsonFile(os.path.join(Hub.CfgDir, bansFile))
    if read_bans:
        for read_ban_sec in read_bans:
            for read_ban in read_bans[read_ban_sec]:
                ban = Ban()
                ban.update(read_bans[read_ban_sec][read_ban])
                bans[read_ban_sec][read_ban] = ban

    bansLock.release()
    fileLock.release()
    
    cmdINF = autil.handleCommand(onINF,adchpp.AdcCommand.CMD_INF)
    cmdMSG = autil.handleCommand(onMSG,adchpp.AdcCommand.CMD_MSG)

    CommandManager.add(CommandManager.Command(key='ban', alias=['banuser'], command=banUser, minLevel=SettingManager.settings['level_op'],category="BanManager", helpTxt="nick [reason] [seconds (format: 1w2d3h4m5s)] - ban an online user (set seconds to 0 to un-ban)",
                                    user_command=[CommandManager.UserCommand(contexts=CommandManager.context_userlist,command="ban " + "%[userNI]" + " " + CommandManager.createLine("Reason (facultative)") + " " + CommandManager.createLine("Seconds (facultative) (format: 1w2d3h4m5s)"), path='ADCH++/Hub management/Punish/Ban'),
                                                  CommandManager.UserCommand(contexts=CommandManager.context_hub,command="ban " + CommandManager.createLine("Nick") + " " + CommandManager.createLine("Reason (facultative)") + " " + CommandManager.createLine("Seconds (facultative) (format: 1w2d3h4m5s)"), path='ADCH++/Hub management/Punish/Ban')]))

    CommandManager.add(CommandManager.Command(key='bancid', command=banCID, minLevel=SettingManager.settings['level_op'],category="BanManager", helpTxt="CID [reason] [seconds (format: 1w2d3h4m5s)] (set seconds to 0 to un-ban)",
                                    user_command=[CommandManager.UserCommand(contexts=CommandManager.context_userlist,command="banCID " + "%[userCID]" + " " + CommandManager.createLine("Reason (facultative)") + " " + CommandManager.createLine("Seconds (facultative) (format: 1w2d3h4m5s)"), path='ADCH++/Hub management/Punish/Ban CID'),
                                                  CommandManager.UserCommand(contexts=CommandManager.context_hub,command="banCID " + CommandManager.createLine("CID") + " " + CommandManager.createLine("Reason (facultative)") + " " + CommandManager.createLine("Seconds (facultative) (format: 1w2d3h4m5s)"), path='ADCH++/Hub management/Punish/Ban CID')]))

    CommandManager.add(CommandManager.Command(key='banip', command=banIP, minLevel=SettingManager.settings['level_op'],category="BanManager", helpTxt="IP [reason] [seconds (format: 1w2d3h4m5s)] (set seconds to 0 to un-ban)",
                                    user_command=[CommandManager.UserCommand(contexts=CommandManager.context_userlist,command="banIP " + "%[userI4]" + " " + CommandManager.createLine("Reason (facultative)") + " " + CommandManager.createLine("Seconds (facultative) (format: 1w2d3h4m5s)"), path='ADCH++/Hub management/Punish/Ban IP'),
                                                  CommandManager.UserCommand(contexts=CommandManager.context_hub,command="banIP " + CommandManager.createLine("IP") + " " + CommandManager.createLine("Reason (facultative)") + " " + CommandManager.createLine("Seconds (facultative) (format: 1w2d3h4m5s)"), path='ADCH++/Hub management/Punish/Ban IP')]))

    CommandManager.add(CommandManager.Command(key='bannick', command=banNick, minLevel=SettingManager.settings['level_op'],category="BanManager", helpTxt="nick [reason] [seconds (format: 1w2d3h4m5s)] (set seconds to 0 to un-ban)",
                                    user_command=[CommandManager.UserCommand(contexts=CommandManager.context_userlist,command="bannick " + "%[userNI]" + " " + CommandManager.createLine("Reason (facultative)") + " " + CommandManager.createLine("Seconds (facultative) (format: 1w2d3h4m5s)"), path='ADCH++/Hub management/Punish/Ban Nick'),
                                                  CommandManager.UserCommand(contexts=CommandManager.context_hub,command="bannick " + CommandManager.createLine("Nick") + " " + CommandManager.createLine("Reason (facultative)") + " " + CommandManager.createLine("Seconds (facultative) (format: 1w2d3h4m5s)"), path='ADCH++/Hub management/Punish/Ban Nick')]))

    CommandManager.add(CommandManager.Command(key='bannickre', command=banNickRE, minLevel=SettingManager.settings['level_op'],category="BanManager", helpTxt="<nick-reg-exp> [reason] [seconds (format: 1w2d3h4m5s)] - ban nicks that match the given reg exp (must be within '<' and '>' brackets) (set seconds to 0 to un-ban)",
                                    user_command=[CommandManager.UserCommand(contexts=CommandManager.context_userlist+CommandManager.context_hub,command="bannickre <" + CommandManager.createLine("Reg exp of nicks to forbid") + "> " + CommandManager.createLine("Reason (facultative)") + " " + CommandManager.createLine("Seconds (facultative) (format: 1w2d3h4m5s)"), path='ADCH++/Hub management/Punish/Ban Nick (reg exp)')]))

    CommandManager.add(CommandManager.Command(key='banmsgre', command=banMsgRE, minLevel=SettingManager.settings['level_op'],category="BanManager", helpTxt="<msg-reg-exp> [reason] [secondstostayactive (format: 1w2d3h4m5s)] [secondstoban (format: 1w2d3h4m5s)] - ban originators of messages that match the given reg exp (must be within '<' and '>' brackets) (set seconds to 0 to un-ban)",
                                    user_command=[CommandManager.UserCommand(contexts=CommandManager.context_userlist+CommandManager.context_hub,command="banmsgre <" + CommandManager.createLine("Reg exp of chat messages to forbid") + "> " + CommandManager.createLine("Reason (facultative)") + " " + CommandManager.createLine("Seconds to stay active (facultative) (format: 1w2d3h4m5s)") + " " + CommandManager.createLine("Seconds to ban (facultative) (format: 1w2d3h4m5s)"), path='ADCH++/Hub management/Punish/Ban Chat (reg exp)')]))

    CommandManager.add(CommandManager.Command(key='mute', alias=['stfu'], command=mute, minLevel=SettingManager.settings['level_op'],category="BanManager", helpTxt="nick [reason] [seconds (format: 1w2d3h4m5s)] - mute an online user (set seconds to 0 to un-mute)",
                                              user_command=[CommandManager.UserCommand(contexts=CommandManager.context_userlist,command="mute " + "%[userNI]" + " " + CommandManager.createLine("Reason (facultative)") + " " + CommandManager.createLine("Seconds (facultative) (format: 1w2d3h4m5s)"), path='ADCH++/Hub management/Punish/Mute'),
                                              CommandManager.UserCommand(contexts=CommandManager.context_hub,command="mute <" + CommandManager.createLine("Nick") + "> " + CommandManager.createLine("Reason (facultative)") + " " + CommandManager.createLine("Seconds (facultative) (format: 1w2d3h4m5s)"), path='ADCH++/Hub management/Punish/Mute')]))

    CommandManager.add(CommandManager.Command(key='listbans', alias=['listban', 'listbanned', 'showban', 'showbans', 'showbanned'],category="BanManager", command=listBans, minLevel=SettingManager.settings['level_op'], helpTxt="<msg-reg-exp> [reason] [seconds (format: 1w2d3h4m5s)] - ban originators of messages that match the given reg exp (must be within '<' and '>' brackets) (set seconds to 0 to un-ban)",
                                    user_command=[CommandManager.UserCommand(contexts=CommandManager.context_userlist+CommandManager.context_hub,command="listbans", path='ADCH++/Hub management/List Bans')]))

    initiated = True

def saveBans():
    if initiated:
        fileLock.acquire()
        autil.saveJsonFile(bans, os.path.join(Hub.CfgDir , bansFile))
        fileLock.release()

def make_ban(level, reason, seconds):
    ban = Ban(level = level)
    if len(reason) > 0:
        ban.reason = reason
    if seconds:
        ban.expires = time.time() + seconds
    return ban

def checkExpired(ban):
    diff = ban.expires - time.time()

    if diff <= 0:
        return True
    
    return False

def ban_expiration_string(dt):
    if dt != float("inf"):
        diff = dt - time.time()
        if diff > 0:
            return "in " + autil.format_seconds(diff)
        else:
            return "expired"
    else:
        return "never"

def ban_info_string(ban, sep = None):
    if not sep:
        sep = "\t"

    info = "Level: " + str(ban.level)

    if ban.reason:
        info += sep + "Reason: " + str(ban.reason)

    if ban.reexpires:
        info += sep + "Bans expire: " + ban_expiration_string(time.time() + ban.reexpires)
        info += sep + "Expires: " + ban_expiration_string(ban.expires)
    else:
        info += sep + "Expires: " + ban_expiration_string(ban.expires)
        
    return info

def ban_return_info(ban):
    info = " (expires: " + ban_expiration_string(ban.expires) + ")"
    if ban.reason:
        info += " (reason: " + str(ban.reason) + ")"
    return info

def dump_banned(c, ban):
    strBan = "You are banned" + ban_return_info(ban)

    err = None
    if ban.expires == float("inf"):
        err = adchpp.AdcCommand.ERROR_PERM_BANNED
    elif ban.expires > 0:
        err = adchpp.AdcCommand.ERROR_TEMP_BANNED
    else:
        err = adchpp.AdcCommand.ERROR_BANNED_GENERIC

    def addParams(cmd):
        cmd.addParam("MS", strBan)

        expires = 0
        if ban.expires == float("inf"):
            expires = -1
        else:
            expires = ban.expires
           
        cmd.addParam("TL" + str(expires))

    autil.dump(c, err, adchpp.Util.REASON_PLUGIN, addParams)

def banUser(ent, cmd, params, public):
    level = UserManager.getLevel(ent)
    if level < SettingManager.settings['level_op'].value:
        return

    if len(params) > 0:
        params = params[0]
    else:
        autil.hub_reply(ent, "No arguments supplied")
        return

    time_search = re.search(reTime_or_inf,params)
    seconds = 0

    if time_search:
        params = params[0:len(params)-len(time_search.group(0))]
        
        inf = time_search.group(6)
        if inf: #inf
            seconds = float("inf")
        else:
            week = time_search.group(1)
            day = time_search.group(2)
            hour = time_search.group(3)
            minute = time_search.group(4)
            second = time_search.group(5)
            #convert to seconds
            if week:
                seconds += float(week)*7*24*60*60
            if day:
                seconds += float(day)*24*60*60
            if hour:
                seconds += float(hour)*60*60
            if minute:
                seconds += float(minute)*60
            if second:
                seconds += float(second)

    #seconds_search = re.search(float_at_end_or_inf, params)
    #seconds = 0
    #
    #if seconds_search and len(seconds_search.group(0)) != 0:
    #    params = params[0:len(params)-len(seconds_search.group(0))]
    #    seconds = float(seconds_search.group(1))
    #        
    #    if len(params) <= 0:
    #        autil.hub_reply(ent, "Bad arguments")
    #        return
    
    params = re.search("^(\S+) ?(.*)", params)
    
    if not params:
        autil.hub_reply(ent, "You need to supply a nick")
        return

    nick = params.group(1)
    reason = params.group(2)

    victim = Hub.ClientMgr.findByNick(nick)
    if victim:
        victim = victim.asClient()
    if not victim:
        autil.hub_reply(ent, "No user named \"" + nick + "\"")
        return

    victim_cid = victim.getCID().toBase32()
    victim_user = UserManager.findUser(nick, victim_cid)
    if victim_user and level <= victim_user.level:
        autil.hub_reply(ent, "You can't ban users whose level is higher or equal than yours")
        return
    
    if seconds != 0:
        ban = make_ban(level, reason, seconds)
        bansLock.acquire()
        cids[victim_cid] = ban
        bansLock.release()
        saveBans()
        dump_banned(victim, ban)
        autil.hub_reply(ent, "\"" + nick + "\" (CID: " + victim_cid + ") is now banned (" + ban_info_string(ban, ") (") + ")")
        autil.ent_reply_ME(ent, 'has banned "' + nick + '" (' + ban_info_string(ban, ') (') + ')')
        return
    
    if victim_cid in cids:
        bansLock.acquire()
        del(cids[victim_cid])
        bansLock.release()
        saveBans()
        autil.hub_reply(ent, "\"" + nick + "\" (CID: " + victim_cid + ") is now un-banned")
    else: #Super flawed, how can you unban them unless they are online, and to be online they have to be not banned
        autil.hub_reply(ent, "\"" + nick + "\" (CID: " + victim_cid + ") is not in the banlist")

def banCID(ent, cmd, params, public):
    level = UserManager.getLevel(ent)
    if level < SettingManager.settings['level_op'].value:
        return

    if len(params) > 0:
        params = params[0]
    else:
        autil.hub_reply(ent, "No arguments supplied")
        return

    time_search = re.search(reTime_or_inf,params)
    seconds = 0

    if time_search:
        params = params[0:len(params)-len(time_search.group(0))]
        
        inf = time_search.group(6)
        if inf: #inf
            seconds = float("inf")
        else:
            week = time_search.group(1)
            day = time_search.group(2)
            hour = time_search.group(3)
            minute = time_search.group(4)
            second = time_search.group(5)
            #convert to seconds
            if week:
                seconds += float(week)*7*24*60*60
            if day:
                seconds += float(day)*24*60*60
            if hour:
                seconds += float(hour)*60*60
            if minute:
                seconds += float(minute)*60
            if second:
                seconds += float(second)

    #seconds_search = re.search(float_at_end_or_inf, params)
    #seconds = 0
    #
    #if seconds_search and len(seconds_search.group(0)) != 0:
    #    params = params[0:len(params)-len(seconds_search.group(0))]
    #    seconds = float(seconds_search.group(1))
    #        
    #    if len(params) <= 0:
    #        autil.hub_reply(ent, "Bad arguments")
    #        return
    
    params = re.search("^(\S+) ?(.*)", params)
    
    if not params:
        autil.hub_reply(ent, "You need to supply a CID")
        return

    cid = params.group(1)
    reason = params.group(2)

    #victim = Hub.ClientMgr.findByCID(adchpp.CID(cid))
    #if victim:
    #    victim = victim.asClient()

    #victim_user = UserManager.findUser(None, cid)
    #if victim_user and level <= victim_user.level:
    #    autil.hub_reply(ent, "You can't ban users whose level is higher or equal than yours")
    #    return
    
    if seconds != 0:
        ban = make_ban(level, reason, seconds)
        bansLock.acquire()
        cids[cid] = ban
        bansLock.release()
        saveBans()
        #if victim:
        #    dump_banned(victim, ban)
        autil.hub_reply(ent, "The CID \"" + cid + "\" is now banned (" + ban_info_string(ban, ") (") + ")")
        #autil.ent_reply_ME(ent, 'has banned CID "' + cid + '" (' + ban_info_string(ban, ') (') + ')')
        return
    
    if cid in cids:
        bansLock.acquire()
        del(cids[cid])
        bansLock.release()
        saveBans()
        autil.hub_reply(ent, "The CID \"" + cid + "\" is now un-banned")
    else:
        autil.hub_reply(ent, "The CID \"" + cid + "\" is not in the banlist")

def banIP(ent, cmd, params, public):
    level = UserManager.getLevel(ent)
    if level < SettingManager.settings['level_op'].value:
        return

    if len(params) > 0:
        params = params[0]
    else:
        autil.hub_reply(ent, "No arguments supplied")
        return

    time_search = re.search(reTime_or_inf,params)
    seconds = 0

    if time_search:
        params = params[0:len(params)-len(time_search.group(0))]
        
        inf = time_search.group(6)
        if inf: #inf
            seconds = float("inf")
        else:
            week = time_search.group(1)
            day = time_search.group(2)
            hour = time_search.group(3)
            minute = time_search.group(4)
            second = time_search.group(5)
            #convert to seconds
            if week:
                seconds += float(week)*7*24*60*60
            if day:
                seconds += float(day)*24*60*60
            if hour:
                seconds += float(hour)*60*60
            if minute:
                seconds += float(minute)*60
            if second:
                seconds += float(second)

    #seconds_search = re.search(float_at_end_or_inf, params)
    #seconds = 0
    #
    #if seconds_search and len(seconds_search.group(0)) != 0:
    #    params = params[0:len(params)-len(seconds_search.group(0))]
    #    seconds = float(seconds_search.group(1))
    #        
    #    if len(params) <= 0:
    #        autil.hub_reply(ent, "Bad arguments")
    #        return
    
    params = re.search("^(\S+) ?(.*)", params)
    
    if not params:
        autil.hub_reply(ent, "You need to supply an IP address")
        return

    ip = params.group(1)
    reason = params.group(2)
    
    if seconds != 0:
        ban = make_ban(level, reason, seconds)
        bansLock.acquire()
        ips[ip] = ban
        bansLock.release()
        saveBans()
        autil.hub_reply(ent, "The IP address \"" + ip + "\" is now banned (" + ban_info_string(ban, ") (") + ")")
        return
    
    if ip in ips:
        bansLock.acquire()
        del(ips[ip])
        bansLock.release()
        saveBans()
        autil.hub_reply(ent, "The IP address \"" + ip + "\" is now un-banned")
    else:
        autil.hub_reply(ent, "The IP address \"" + ip + "\" is not in the banlist")

def banNick(ent, cmd, params, public):
    level = UserManager.getLevel(ent)
    if level < SettingManager.settings['level_op'].value:
        return

    if len(params) > 0:
        params = params[0]
    else:
        autil.hub_reply(ent, "No arguments supplied")
        return

    time_search = re.search(reTime_or_inf,params)
    seconds = 0

    if time_search:
        params = params[0:len(params)-len(time_search.group(0))]
        
        inf = time_search.group(6)
        if inf: #inf
            seconds = float("inf")
        else:
            week = time_search.group(1)
            day = time_search.group(2)
            hour = time_search.group(3)
            minute = time_search.group(4)
            second = time_search.group(5)
            #convert to seconds
            if week:
                seconds += float(week)*7*24*60*60
            if day:
                seconds += float(day)*24*60*60
            if hour:
                seconds += float(hour)*60*60
            if minute:
                seconds += float(minute)*60
            if second:
                seconds += float(second)

        
    #seconds_search = re.search(float_at_end_or_inf, params)
    #seconds = 0
    #
    #if seconds_search and len(seconds_search.group(0)) != 0:
    #    params = params[0:len(params)-len(seconds_search.group(0))]
    #    seconds = float(seconds_search.group(1))
    #        
    #    if len(params) <= 0:
    #        autil.hub_reply(ent, "Bad arguments")
    #        return
    
    params = re.search("^(\S+) ?(.*)", params)
    
    if not params:
        autil.hub_reply(ent, "You need to supply a nick")
        return

    nick = params.group(1)
    reason = params.group(2)
    
    if seconds != 0:
        ban = make_ban(level, reason, seconds)
        bansLock.acquire()
        nicks[nick] = ban
        bansLock.release()
        saveBans()
        autil.hub_reply(ent, "The nick \"" + nick + "\" is now banned (" + ban_info_string(ban, ") (") + ")")
        return
    
    if nick in nicks:
        bansLock.acquire()
        del(nicks[nick])
        bansLock.release()
        saveBans()
        autil.hub_reply(ent, "The nick \"" + nick + "\" is now un-banned")
    else:
        autil.hub_reply(ent, "The nick \"" + nick + "\" is not in the banlist")

def banNickRE(ent, cmd, params, public):
    level = UserManager.getLevel(ent)
    if level < SettingManager.settings['level_op'].value:
        return

    if len(params) > 0:
        params = params[0]
    else:
        autil.hub_reply(ent, "No arguments supplied")
        return

    time_search = re.search(reTime_or_inf,params)
    seconds = 0

    if time_search:
        params = params[0:len(params)-len(time_search.group(0))]
        
        inf = time_search.group(6)
        if inf: #inf
            seconds = float("inf")
        else:
            week = time_search.group(1)
            day = time_search.group(2)
            hour = time_search.group(3)
            minute = time_search.group(4)
            second = time_search.group(5)
            #convert to seconds
            if week:
                seconds += float(week)*7*24*60*60
            if day:
                seconds += float(day)*24*60*60
            if hour:
                seconds += float(hour)*60*60
            if minute:
                seconds += float(minute)*60
            if second:
                seconds += float(second)

    #seconds_search = re.search(float_at_end_or_inf, params)
    #seconds = 0
    #
    #if seconds_search and len(seconds_search.group(0)) != 0:
    #    params = params[0:len(params)-len(seconds_search.group(0))]
    #    seconds = float(seconds_search.group(1))
    #        
    #    if len(params) <= 0:
    #        autil.hub_reply(ent, "Bad arguments")
    #        return
    
    params = re.search("<([^>]+)> ?(.*)", params)
    
    if not params:
        autil.hub_reply(ent, "You need to supply a reg exp (within '<' and '>' brackets)")
        return

    nickre = params.group(1)
    reason = params.group(2)
    
    if seconds != 0:
        ban = make_ban(level, reason, seconds)
        bansLock.acquire()
        nicksre[nickre] = ban
        bansLock.release()
        saveBans()
        autil.hub_reply(ent, "Nicks that match \"" + nickre + "\" is now banned (" + ban_info_string(ban, ") (") + ")")
        return
    
    if nickre in nicksre:
        bansLock.acquire()
        del(nicksre[nickre])
        bansLock.release()
        saveBans()
        autil.hub_reply(ent, "Nicks that match \"" + nickre + "\" are now removed from the banlist")
    else:
        autil.hub_reply(ent, "Nicks that match \"" + nickre + "\" are not found in the banlist")

def banMsgRE(ent, cmd, params, public):
    level = UserManager.getLevel(ent)
    if level < SettingManager.settings['level_op'].value:
        return

    if len(params) > 0:
        params = params[0]
    else:
        autil.hub_reply(ent, "No arguments supplied")
        return

    time_search = re.search(reTime_or_inf,params)
    seconds = 0

    if time_search:
        params = params[0:len(params)-len(time_search.group(0))]
        
        inf = time_search.group(6)
        if inf: #inf
            seconds = float("inf")
        else:
            week = time_search.group(1)
            day = time_search.group(2)
            hour = time_search.group(3)
            minute = time_search.group(4)
            second = time_search.group(5)
            #convert to seconds
            if week:
                seconds += float(week)*7*24*60*60
            if day:
                seconds += float(day)*24*60*60
            if hour:
                seconds += float(hour)*60*60
            if minute:
                seconds += float(minute)*60
            if second:
                seconds += float(second)

    duration_search = re.search(reTime_or_inf,params)
    duration = 0

    if time_search:
        params = params[0:len(params)-len(duration_search.group(0))]
        
        inf = duration_search.group(6)
        if inf: #inf
            duration = float("inf")
        else:
            week = duration_search.group(1)
            day = duration_search.group(2)
            hour = duration_search.group(3)
            minute = duration_search.group(4)
            second = duration_search.group(5)
            #convert to seconds
            if week:
                duration += float(week)*7*24*60*60
            if day:
                duration += float(day)*24*60*60
            if hour:
                duration += float(hour)*60*60
            if minute:
                duration += float(minute)*60
            if second:
                duration += float(second)

    #seconds_search = re.search(float_at_end_or_inf, params)
    #seconds = 0
    #
    #if seconds_search and len(seconds_search.group(0)) != 0:
    #    params = params[0:len(params)-len(seconds_search.group(0))]
    #    seconds = float(seconds_search.group(1))
    #        
    #    if len(params) <= 0:
    #        autil.hub_reply(ent, "Bad arguments")
    #        return
    
    params = re.search("<([^>]+)> ?(.*)", params)
    
    if not params:
        autil.hub_reply(ent, "You need to supply a reg exp (within '<' and '>' brackets)")
        return

    inMsgRE = params.group(1)
    reason = params.group(2)
    
    if seconds != 0:
        ban = make_ban(level, reason, duration)
        ban.reexpires = seconds
        bansLock.acquire()
        msgsre[inMsgRE] = ban
        bansLock.release()
        saveBans()
        autil.hub_reply(ent, "Messages that match \"" + inMsgRE + "\" is now banned (" + ban_info_string(ban, ") (") + ")")
        return
    
    if inMsgRE in msgsre:
        bansLock.acquire()
        del(msgsre[inMsgRE])
        bansLock.release()
        saveBans()
        autil.hub_reply(ent, "Messages that match \"" + inMsgRE + "\" are now removed from the banlist")
    else:
        autil.hub_reply(ent, "Messages that match \"" + inMsgRE + "\" are not found in the banlist")

def mute(ent, cmd, params, public):
    level = UserManager.getLevel(ent)
    if level < SettingManager.settings['level_op'].value:
        return

    if len(params) > 0:
        params = params[0]
    else:
        autil.hub_reply(ent, "No arguments supplied")
        return

    time_search = re.search(reTime_or_inf,params)
    seconds = 0

    if time_search:
        params = params[0:len(params)-len(time_search.group(0))]
        
        inf = time_search.group(6)
        if inf: #inf
            seconds = float("inf")
        else:
            week = time_search.group(1)
            day = time_search.group(2)
            hour = time_search.group(3)
            minute = time_search.group(4)
            second = time_search.group(5)
            #convert to seconds
            if week:
                seconds += float(week)*7*24*60*60
            if day:
                seconds += float(day)*24*60*60
            if hour:
                seconds += float(hour)*60*60
            if minute:
                seconds += float(minute)*60
            if second:
                seconds += float(second)

    #seconds_search = re.search(float_at_end_or_inf, params)
    #seconds = 0
    #
    #if seconds_search and len(seconds_search.group(0)) != 0:
    #    params = params[0:len(params)-len(seconds_search.group(0))]
    #    seconds = float(seconds_search.group(1))
    #        
    #    if len(params) <= 0:
    #        autil.hub_reply(ent, "Bad arguments")
    #        return
    
    params = re.search("^(\S+) ?(.*)", params)
    
    if not params:
        autil.hub_reply(ent, "You need to supply a nick")
        return

    nick = params.group(1)
    reason = params.group(2)

    victim = Hub.ClientMgr.findByNick(nick)
    if victim:
        victim = victim.asClient()
    if not victim:
        autil.hub_reply(ent, "No user named \"" + nick + "\"")
        return

    victim_cid = victim.getCID().toBase32()
    victim_user = UserManager.findUser(nick, victim_cid)
    if victim_user and level <= victim_user.level:
        autil.hub_reply(ent, "You can't mute users whose level is higher or equal than yours")
        return
    
    if seconds != 0:
        ban = make_ban(level, reason, seconds)
        bansLock.acquire()
        muted[victim_cid] = ban
        bansLock.release()
        saveBans()
        #dump_banned(victim, ban)
        autil.hub_reply(ent, "\"" + nick + "\" (CID: " + victim_cid + ") is now muted (" + ban_info_string(ban, ") (") + ")")
        autil.ent_reply_ME(ent, 'has muted "' + nick + '" (' + ban_info_string(ban, ') (') + ')')
        return
    
    if victim_cid in muted:
        bansLock.acquire()
        del(muted[victim_cid])
        bansLock.release()
        saveBans()
        autil.hub_reply(ent, "\"" + nick + "\" (CID: " + victim_cid + ") is now un-muted")
        autil.ent_reply_ME(ent, 'has unmuted "' + nick + '"')
    else: #Super flawed, how can you unmute them unless they are online, and to be online they have to be not banned
        autil.hub_reply(ent, "\"" + nick + "\" (CID: " + victim_cid + ") is not in the mutelist")

def listBans(ent, cmd, params, public):
    level = UserManager.getLevel(ent)
    if level < SettingManager.settings['level_op'].value:
        return

    needToSave = False
    toRemove = []
    bansLock.acquire()
    strList = "\nCID bans:"
    for cid in cids:
        if checkExpired(cids[cid]):
            toRemove.append(cid)
            needToSave = True
        else:
            strList += "\n\tCID: " + cid + "\t" + ban_info_string(cids[cid])
    if toRemove:
        for key in toRemove:
            del(cids[key])
        toRemove = []
        

    strList += "\n\nIP bans:"
    for ip in ips:
        if checkExpired(ips[ip]):
            toRemove.append(ip)
            needToSave = True
        else:
            strList += "\n\tIP: " + ip + "\t" + ban_info_string(ips[ip])
    if toRemove:
        for key in toRemove:
            del(ips[key])
        toRemove = []
    
    strList += "\n\nNick bans:"
    for nick in nicks:
        if checkExpired(nicks[nick]):
            toRemove.append(nick)
            needToSave = True
        else:
            strList += "\n\tNick: " + nick + "\t" + ban_info_string(nicks[nick])
    if toRemove:
        for key in toRemove:
            del(nicks[key])
        toRemove = []

    strList += "\n\nNick bans (reg exp):"
    for nickre in nicksre:
        if checkExpired(nicksre[nickre]):
            toRemove.append(nickre)
            needToSave = True
        else:
            strList += "\n\tReg exp: " + nickre + "\t" + ban_info_string(nicksre[nickre])
    if toRemove:
        for key in toRemove:
            del(nicksre[key])
        toRemove = []

    strList += "\n\nMessage bans (reg exp):"
    for msgre in msgsre:
        if checkExpired(msgsre[msgre]):
            toRemove.append(msgre)
            needToSave = True
        else:
            strList += "\n\tReg exp: " + msgre + "\t" + ban_info_string(msgsre[msgre])
    if toRemove:
        for key in toRemove:
            del(msgsre[key])
        toRemove = []

    strList += "\n\nMuted:"
    for cid in muted:
        if checkExpired(muted[cid]):
            toRemove.append(cid)
            needToSave = True
        else:
            strList += "\n\tCID: " + cid + "\t" + ban_info_string(muted[cid])
    if toRemove:
        for key in toRemove:
            del(muted[key])
        toRemove = []

    autil.hub_reply(ent, strList)

    if needToSave:
        saveBans()
    bansLock.release()

def onMSG(ent, cmd, ok):
    cid = ent.getCID().toBase32()
    level = UserManager.getLevel(ent)

    needToSave = False
    bansLock.acquire()
    if cid in muted:
        if checkExpired(muted[cid]):
            del(muted[cid])
            needToSave = True
        else:
            if level < muted[cid].level:
                autil.hub_reply(ent, "You are muted" + ban_return_info(muted[cid]))
                if needToSave:
                    saveBans()
                bansLock.release()
                return False

    
    msg = cmd.getParam(0)
    toRemove = []
    for key in msgsre:
        regban = msgsre[key]
        if checkExpired(regban):
            toRemove.append(key)
            needToSave = True
        else:
            if regban.level > level and re.match(key,msg):
                ban = Ban(level = regban.level, reason = regban.reason, expires = time.time() + regban.reexpires)
                cids[cid] = ban
                saveBans()
                dump_banned(ent.asClient(), ban)
                if toRemove:
                    for key in toRemove:
                        del(msgsre[key])
                if needToSave:
                    saveBans()
                bansLock.release()
                return False
            
    if toRemove:
        for key in toRemove:
            del(msgsre[key])
    if needToSave:
        saveBans()
    bansLock.release()
    return True

def onINF(ent, cmd, ok):
    cid = None
    nick = None

    c = ent.asClient()

    if c.getState() == adchpp.Entity.STATE_NORMAL:
        cid = c.getCID().toBase32()
        nick = c.getField("NI")
    else:
        cid = cmd.getParam("ID", 0)[1]
        nick = cmd.getParam("NI", 0)[1]

    infbans = []
    needToSave = False
    bansLock.acquire()
    if cid in cids:
        if checkExpired(cids[cid]):
            del(cids[cid])
            needToSave = True
        else:
            infbans.append(cids[cid])
    elif c.getIp() in ips:
        if checkExpired(ips[c.getIp()]):
            del(ips[c.getIp()])
            needToSave = True
        else:
            infbans.append(ips[c.getIp()])
    elif nick in nicks:
        if checkExpired(nicks[nick]):
            del(nicks[nick])
            needToSave = True
        else:
            infbans.append(nicks[nick])
    else:
        for key in nicksre:
            if re.match(key, nick):
                if checkExpired(nicksre[key]):
                    del(nicksre[key])
                    needToSave = True
                else:
                    infbans.append(nicksre[key])
                    break

    for ban in infbans:
        if ban and ban.level > UserManager.getLevel(ent):
            dump_banned(c, ban)
            if needToSave:
                saveBans()
            bansLock.release()
            return False

    if needToSave:
        saveBans()
    bansLock.release()
    return True
