import pyadchpp as adchpp
import Hub
import threading

entCmdListLock = threading.Lock()
entCmdsToSend = []
entSend = None

clientCmdListLock = threading.Lock()
clientCmdsToSend = []
clientSend = None

'''clientMgrCmdListLock = threading.Lock()
clientMgrCmdsToSend = []
clientMgrSendAll = None'''

clientDisconnectListLock = threading.Lock()
clientDisconnectsToSend = []
clientDisconnect = None

cmdSenderTimer = None

def initModule():
    global entSend, clientSend, clientMgrSendAll, clientDisconnect

    entSend = adchpp.Entity.send
    adchpp.Entity.send = entCmdSendCallback

    clientSend = adchpp.Client.send
    adchpp.Client.send = clientCmdSendCallback

    #cmd goes out of scope and gets destroyed before BufferPtr can be used
    '''clientMgrSendAll = Hub.ClientMgr.sendToAll
    Hub.ClientMgr.sendToAll = clientMgrCmdSendCallback'''

    clientDisconnect = adchpp.Client.disconnect
    adchpp.Client.disconnect = clientDisconnectsCallback

    cmdSenderTimer = Hub.SocketMgr.addTimedJob(500, sendCommands)

#callbacks for all functions that might be called by threads
def entCmdSendCallback(ent, cmd):
    entCmdListLock.acquire()
    entCmdsToSend.append([ent, cmd])
    entCmdListLock.release()

def clientCmdSendCallback(client, cmd):
    clientCmdListLock.acquire()
    clientCmdsToSend.append([client, cmd])
    clientCmdListLock.release()

'''def clientMgrCmdSendCallback(buffer):
    clientMgrCmdListLock.acquire()
    clientMgrCmdsToSend.append(buffer)
    clientMgrCmdListLock.release()'''

def clientDisconnectsCallback(client, reason, string = ""):
    clientDisconnectListLock.acquire()
    clientDisconnectsToSend.append([client, reason, string])
    clientDisconnectListLock.release()

def sendCommands():
    #Entity.Send
    entCmdListLock.acquire()
    global entCmdsToSend
    for ent, cmd in entCmdsToSend:
        entSend(ent, cmd)
    entCmdsToSend = []
    entCmdListLock.release()

    #Client.Send
    clientCmdListLock.acquire()
    global clientCmdsToSend
    for client, cmd in clientCmdsToSend:
        clientSend(client, cmd)
    clientCmdsToSend = []
    clientCmdListLock.release()

    #Client.disconnect
    clientDisconnectListLock.acquire()
    global clientDisconnectsToSend
    for client, reason, string in clientDisconnectsToSend:
        clientDisconnect(client, reason, string)
    clientDisconnectsToSend = []
    clientDisconnectListLock.release()

    '''#ClientManager.SendToAll
    clientMgrCmdListLock.acquire()
    global clientMgrCmdsToSend
    for buffer in clientMgrCmdsToSend:
        clientMgrSendAll(buffer)
    clientMgrCmdsToSend = []
    clientMgrCmdListLock.release()'''