import pyadchpp as adchpp
import Hub
import sys, os, shlex, re, time
import json
import autil
import SettingManager, CommandManager
import threading

sys.path.append(os.path.abspath('../'))

users = []
usersLock = threading.RLock()

nicks = {}
cids = {}
staticids = {} #staticIDs, unique unchanging identifier for user

usersFile = 'users.txt'
fileLock = threading.RLock()

saveTimer = None;
saved = True;
initiated = False

lastStaticid = 0;

class User(dict):
    def __init__(self, nick = None, cid = None, staticid = None, password = None, passhash = None, salt = None, level = 0, lastofftime = 0, lasttime = 0, regtime = 0, regby = ""):        
    #def __init__(self, nick = None, cid = None, staticid = None, passhash = None, salt = None, level = 0, lastofftime = 0, lasttime = 0, regtime = 0, regby = ""):        
        self['nick'] = nick
        self['cid'] = cid
        self['staticid'] = staticid
        self['password'] = password
        #self['passhash'] = passhash
        #self['salt'] = salt
        self['level'] = level
        self['lastofftime'] = float(lastofftime)
        self['lasttime'] = float(lasttime)
        self['regtime'] = float(regtime)
        self['regby'] = regby

    nick = property(lambda self: self['nick'], (lambda self,x: self.__setitem__('nick', x)))
    cid = property(lambda self: self['cid'], (lambda self,x: self.__setitem__('cid', x)))
    staticid = property(lambda self: self['staticid'], (lambda self,x: self.__setitem__('staticid', x)))
    password = property(lambda self: self['password'], (lambda self,x: self.__setitem__('password', x)))
    #passhash = property(lambda self: self['passhash'], (lambda self,x: self.__setitem__('passhash', x)))
    #salt = property(lambda self: self['salt'], (lambda self,x: self.__setitem__('salt', x)))
    level = property(lambda self: self['level'], (lambda self,x: self.__setitem__('level', x)))
    lastofftime = property(lambda self: self['lastofftime'], (lambda self,x: self.__setitem__('lastofftime', x)))
    lasttime = property(lambda self: self['lasttime'], (lambda self,x: self.__setitem__('lasttime', x)))
    regtime = property(lambda self: self['level'], (lambda self,x: self.__setitem__('regtime', x)))
    regby = property(lambda self: self['regby'], (lambda self,x: self.__setitem__('regby', x)))
    regtime = property(lambda self: self['regtime'], (lambda self,x: self.__setitem__('regtime', x)))

    

def initModule():
    global users, nicks, cids, staticids, saveTimer, initiated, lastStaticid
    fileLock.acquire()
    usersLock.acquire()
    read_users = autil.parseJsonFile(os.path.join(Hub.CfgDir, usersFile))
    if read_users:
        for read_user in read_users:
            user = User()
            users.append(user)
            user.update(read_user)
            if user.nick:
                nicks[user.nick] = user
            if user.cid:
                cids[user.cid] = user
            if user.staticid:
                staticids[user.staticid] = user
            """if 'nick' in read_user:
                user.nick = str(read_user['nick'])
                nicks[user.nick] = user
            if 'cid' in read_user:
                user.cid = str(read_user['cid'])
                cids[user.cid] = user
            if 'level' in read_user:
                user.level = int(read_user['level'])
            if 'password' in read_user:
                user.password = str(read_user['password'])
            if 'lastofftime' in read_user:
                user.lastofftime = float(read_user['lastofftime'])
            if 'lasttime' in read_user:
                user.lasttime = float(read_user['lasttime'])
            if 'regtime' in read_user:
                user.regtime = float(read_user['regtime'])
            if 'regby' in read_user:
                user.regby = str(read_user['regby'])"""

    fileLock.release()
    usersLock.release()

    lastStaticid = getHighestStaticID()

    initiated = True

    if len(staticids) != len(users):
        for user in users:
            if not user.staticid:
                lastStaticid += 1
                user.staticid = lastStaticid;
                staticids[user.staticid] = user
        saveUsers()

    SettingManager.add(SettingManager.Setting(key='level_registereduser', helpTxt="The minimum level which is set for a new registered user", value=2))
    SettingManager.add(SettingManager.Setting(key='level_superuser', helpTxt="The minimum level which constitutes a user being a 'superuser'", value=3))
    SettingManager.add(SettingManager.Setting(key='level_op', helpTxt="The minimum level which constitutes a user being a 'operator'", value=6))
    SettingManager.add(SettingManager.Setting(key='allowreg',alias=['allowregistration'],helpTxt="authorize un-regged users to register themselves with +mypass (otherwise, they'll have to ask an operator), 1 = allow, 0 = disallow", value=1))
    SettingManager.add(SettingManager.Setting(key='allownickchange',helpTxt="authorize regged users to connect with a different nick, 1 = allow, 0 = disallow",value=1))
    SettingManager.add(SettingManager.Setting(key='usersave_timer',change=saveTimerChange,helpTxt="the time in seconds to save changes like user logon, logoff time to the userfile.",value=600)) #10 minutes
    CommandManager.add(CommandManager.Command(key='setlevel',alias=['changelevel'],command=changeLevel, minLevel=SettingManager.settings['level_op'], category="UserManagement", helpTxt="nick level - changes a users level, you must have a higher level than the user to change their level.",
                                    user_command=[CommandManager.UserCommand(contexts=CommandManager.context_userlist,command="setlevel " + "%[userNI]" + " " + CommandManager.createLine("Level"), path='ADCH++/Change Level'),
                                                  CommandManager.UserCommand(contexts=CommandManager.context_hub,command="setlevel " + CommandManager.createLine("Nick") + " " + CommandManager.createLine("Level"), path='ADCH++/Change Level')]))
    CommandManager.add(CommandManager.Command(key='regnick',alias=['resetpassword'],command=regnick, minLevel=SettingManager.settings['level_op'], category="UserManagement",helpTxt="[nick] [password] [level] - register a user; use no password to un-reg; level defaults to your own level minus one",
                                    user_command=[CommandManager.UserCommand(contexts=CommandManager.context_userlist,command="regnick " + "%[userNI]" + " " + CommandManager.createLine("Password (leave empty to un-reg)") + " " + CommandManager.createLine("Level (facultative; defaults to your own level minus one)"), path='ADCH++/Register Nick'),
                                                  CommandManager.UserCommand(contexts=CommandManager.context_hub,command="regnick " + CommandManager.createLine("Nick") + " " + CommandManager.createLine("Password (leave empty to un-reg)") + " " + CommandManager.createLine("Level (facultative; defaults to your own level minus one)"), path='ADCH++/Register Nick')]))
    CommandManager.add(CommandManager.Command(key='regme',alias=['passwd','changepass','setpass','setpassword', 'regself'],command=regme,minLevel=0,category="UserManagement", helpTxt="new_pass - change your password, make sure you change it in your client options too. No password to unregister",
                                    user_command=CommandManager.UserCommand(contexts=CommandManager.context_hub + CommandManager.context_userlist,command="regme " + CommandManager.createLine("Password (leave empty to unregister)"), path='ADCH++/Register Self')))
    CommandManager.add(CommandManager.Command(key='listregs', alias=['listregged','listreg','reggedusers','showreg','showregs','showregged'],command=listRegs, category="UserManagement",helpTxt="lists the hubs registered users, optional a nick searchstring parameter", minLevel=1))

    if SettingManager.settings['usersave_timer'].value:
        saveTimer = Hub.SocketMgr.addTimedJob(SettingManager.settings['usersave_timer'].value * 1000,maybeSaveUsers)

def getHighestStaticID():
    staticids_sorted = staticids.keys()
    staticids_sorted.sort()
    if staticids_sorted:
        return staticids_sorted[-1]
    return 0

def saveTimerChange(oldValue, newValue):
    global saveTimer
    if saveTimer:
        saveTimer()
        saveTimer = None

    if newValue:
        saveTimer = Hub.SocketMgr.addTimedJob(SettingManager.settings['usersave_timer'].value  * 1000,maybeSaveUsers)

def listRegs(ent, cmd, params, public):
    calling_user = findUser(ent.getField('NI'), ent.getCID().toBase32())
    if calling_user.level == 0:
        autil.reply(ent, "Only registered users can use this command")
        return

    #param = string.lower(parameters)

    users_sorted = sorted(users, key=(lambda user: user.nick))

    strReply = ""
    if len(params) == 0:
        for user in users_sorted:
            if user.level <= calling_user.level:
                if user.nick:
                    strReply += "\nNick:        " + str(user.nick)
                if user.cid:
                    strReply +=  "\nCID:         " + str(user.cid)
                #if calling_user.level >= SettingManager.settings['level_op'].value and user.level < calling_user.level and user.password: #I don't think this
                #    fields.append("Pass: " + str(user.password))
                if user.lastofftime:
                    strReply += "\nLast logoff: " + time.strftime("%a, %d %b %Y %H:%M:%S %Z",time.localtime(user.lastofftime))
                if user.lasttime:
                    strReply += "\nLast logon:  " + time.strftime("%a, %d %b %Y %H:%M:%S %Z",time.localtime(user.lasttime))
                if user.regtime:
                    strReply += "\nRegistered:  " + time.strftime("%a, %d %b %Y %H:%M:%S %Z",time.localtime(user.regtime))
                if user.regby:
                    strReply += "\nRegged By:   " + str(user.regby)
                if user.level:
                    strReply += "\nLevel:       " + str(user.level)
                strReply += "\n"
        if len(strReply) > 0:
            autil.hub_reply(ent, "Registered users with a level <= " + str(user.level) + " (your level) :\n\n" + strReply + "\n")
        else:
            autil.hub_reply(ent, "There are no registered users with a level <= " + str(user.level) + " (your level) :\n\n")
    else:
        for user in users_sorted:
            if user.nick and str.find(str(user.nick.lower()),str(params[0].lower())) >=0 and user.level <= calling_user.level:
                if user.nick:
                    strReply += "\nNick:        " + str(user.nick)
                if user.cid:
                    strReply +=  "\nCID:         " + str(user.cid)
                #if calling_user.level >= SettingManager.settings['level_op'].value and user.level < calling_user.level and user.password: #I don't think this
                #    fields.append("Pass: " + str(user.password))
                if user.lastofftime:
                    strReply += "\nLast logoff: " + time.strftime("%a, %d %b %Y %H:%M:%S %Z",time.localtime(user.lastofftime))
                if user.lasttime:
                    strReply += "\nLast logon:  " + time.strftime("%a, %d %b %Y %H:%M:%S %Z",time.localtime(user.lasttime))
                if user.regtime:
                    strReply += "\nRegistered:  " + time.strftime("%a, %d %b %Y %H:%M:%S %Z",time.localtime(user.regtime))
                if user.regby:
                    strReply += "\nRegged By:   " + str(user.regby)
                if user.level:
                    strReply += "\nLevel:       " + str(user.level)
                strReply += "\n"
        if len(strReply) > 0:
            autil.hub_reply(ent, "Registered users with a level <= " + str(user.level) + " (your level) :\n\n" + strReply + "\n")
        else:
            autil.hub_reply(ent, "There are no registered users with a level <= " + str(user.level) + " (your level) :\n\n")

def validate_ni(new):
    for char in new:
        if ord(char) <= 32:
                return("the name can't contain any space nor new line")

def regme(ent, cmd, params, public):
    user = findUser(ent.getField("NI"),ent.getCID().toBase32())
    if user:
        # already regged
        if len(params) <= 0 or len(params[0]) <= 0:
            if user.nick and user.nick in nicks:
                del(nicks[user.nick])

            if user.cid and user.cid in cids:
                del(cids[user.cid])

            if user in users:
                users.remove(user)

            saveUsers()

            updateEntFlags(ent)
                
            autil.hub_reply(ent, "You have been un-registered")
            return
        else:
            registerUser(user.cid, user.nick, params[0], user.level, user.regby)
            autil.hub_reply(ent, "Your password has been changed to \"" + params[0] + "\". Remember to update your password in you Hub properties so you log in automatically.")
    elif SettingManager.settings['allowreg'].value != 0:
        if len(params) <= 0 or len(params[0]) <= 0:
            autil.hub_reply(ent, "You must provide a password")
            return
        else:
            registerUser(ent.getCID().toBase32(), ent.getField("NI"), params[0], SettingManager.settings['level_registereduser'].value, ent.getField('NI'))
            autil.hub_reply(ent, "You're now registered with the password \"" + params[0] + "\". Remember to update your password in you Hub properties so you log in automatically.")
    else:
        autil.hub_reply(ent, "You are not allowed to register by yourself; ask an operator to do it for you")
        return
    return

def regnick(ent, cmd, params, public):
    my_user = findUser(ent.getField("NI"), ent.getCID().toBase32())
    
    if len(params) > 0:
        params = params[0]
    else:
        autil.hub_reply(ent, "No arguments supplied")
        return

    level_search = re.search("\s(\d*)$", params)
    level = ""

    if level_search and len(level_search.group(0)) != 0:
        params = params[0:len(params)-len(level_search.group(0))]
        level = int(level_search.group(1))
            
        if len(params) <= 0:
            autil.hub_reply(ent, "Bad arguments")
            return
        
    params = re.match("^(\S+) ?(.*)", params)
    
    if not params:
        autil.hub_reply(ent, "You need to supply a nick")
        return

    nick = params.group(1)
    password = params.group(2)

    validate = validate_ni(nick)
    if validate:
        autil.hub_reply(ent, validate)
        return

    other = Hub.ClientMgr.findByNick(nick)
    cid = None
    if other:
        cid = other.getCID().toBase32()

    other_user = findUser(nick, cid)
    
    if other_user and other_user.level >= my_user.level:
        autil.hub_reply(ent, "There is already a registered user with a level higher or equal than yours with this nick")
        return

    if level and type(level) is str > 0 and len(level) > 0:
        try:
            level = int(level)
        except:
            autil.hub_reply(ent, "Level parameter is invalid: " + str(level))
    elif type(level) is str and len(level) == 0:
        level = my_user.level - 1

    if level >= my_user.level:
        autil.hub_reply(ent, "You may only register to a lower level than your own (" + str(my_user.level) + ")")
        return
    if level < 1:
        autil.hub_reply(ent, "Level too low")
        return

    if len(password) == 0:
        # un-reg
        if not other_user:
            autil.hub_reply(ent, "\"" + nick + "\" is not registered")
            return

        if other_user.nick and other_user.nick in nicks:
            del(nicks[other_user.nick])

        if other_user.cid and other_user.cid in cids:
            del(cids[other_user.cid])

        if other_user in users:
            users.remove(other_user)

        saveUsers()

        autil.hub_reply(ent, "\"" + nick + "\" has been un-registered")

        if other:
            updateEntFlags(other)
            autil.hub_reply(other, "You've been un-registered")
                
        return

    registerUser(cid, nick, password, level, ent.getField('NI'))

    autil.hub_reply(ent, "\"" + nick + "\" has been registered with password \"" + password + "\"")

    if other:
        autil.hub_reply(other, "You've been registered with password \"" + password + "\". Be sure to change your password using " + str(SettingManager.settings['cmd_chr'].value) + "setpassword password and to update your password in you Hub properties so you log in automatically.")

    return

def changeLevel(ent, cmd, params, public):
    my_user = findUser(ent.getField("NI"), ent.getCID().toBase32())
    
    if len(params) > 0:
        params = params[0]
    else:
        autil.hub_reply(ent, "No arguments supplied")
        return

    level_search = re.search("\s(\d*)$", params)
    level = ""

    if level_search and len(level_search.group(0)) != 0:
        params = params[0:len(params)-len(level_search.group(0))]
        level = int(level_search.group(1))

    if len(params) == 0 or level == "":
        autil.hub_reply(ent, "You need to supply a nick and a level")
        return

    nick = params

    other = Hub.ClientMgr.findByNick(nick)
    cid = None
    if other:
        cid = other.getCID().toBase32()

    other_user = findUser(nick, cid)

    if not other_user:
        autil.hub_reply(ent, "No user found with this nick")
        return
    
    if other_user.level >= my_user.level:
        autil.hub_reply(ent, "You can't change the level of a user with a level greater than or equal to your level")
        return

    if level >= my_user.level:
        autil.hub_reply(ent, "You may only change to a lower level than your own (" + str(my_user.level) + ")")
        return
    if level < 1:
        autil.hub_reply(ent, "Level too low")
        return

    lastLevel = other_user.level

    if lastLevel == level:
        autil.hub_reply(ent, "Levels are the same, no change done")
        return

    other_user.level = level

    saveUsers()

    if other:
        updateEntFlags(other)
        if lastLevel < level:
            autil.hub_reply(other, "You've been promoted to level: " + str(level))
        else:
            autil.hub_reply(other, "You've been demoted to level: " + str(level))
    
    if lastLevel < level:
        autil.hub_reply(ent, "\"" + nick + "\" has been promoted to level: " + str(level))
    else:
        autil.hub_reply(ent, "\"" + nick + "\" has been demoted to level: " + str(level))

def saveUsers():
    if initiated:
        fileLock.acquire()
        if autil.saveJsonFile(users, os.path.join(Hub.CfgDir, usersFile)):
            global saved
            saved = True
        fileLock.release()

def maybeSaveUsers():
    if not saved:
        saveUsers()

def userChangesMade():
    global saved
    saved = False

def findUserByEnt(ent):
    return findUser(ent.getField("NI"), ent.getCID().toBase32())

def findUser(nick = None, cid = None, staticid = None):
    if staticid and staticid in staticids:
        return staticids[staticid]
    if cid and cid in cids:
        return cids[cid]
    if nick and nick in nicks:
        return nicks[nick]
    return None

def getLevel(ent):
    nick = ent.getField('NI')
    cid = ent.getCID().toBase32()
    
    if cid in cids:
        if cids[cid].level:
            return cids[cid].level
    if nick in nicks:
        if nicks[nick].level:
            return nicks[nick].level
    return 0

def updateEntFlags(ent):
    if ent and setEntFlags(ent):
        sendEntFlags(ent)

def sendEntFlags(ent):
    cmd = adchpp.AdcCommand(adchpp.AdcCommand.CMD_INF, adchpp.AdcCommand.TYPE_BROADCAST, ent.getSID())
    cmd.addParam("CT", ent.getField("CT"))
    Hub.ClientMgr.sendToAll(cmd.getBuffer())

def setEntFlags(ent):
    user = findUser(ent.getField("NI"), ent.getCID().toBase32())
    change = False
    userLevel = 0

    if not user:
        if ent.isSet(adchpp.Entity.FLAG_REGISTERED):
            ent.unsetFlag(adchpp.Entity.FLAG_REGISTERED)
            change = True
    else:
        if not ent.isSet(adchpp.Entity.FLAG_REGISTERED):
            ent.setFlag(adchpp.Entity.FLAG_REGISTERED)
            change = True
        
        userLevel = user.level
        
    op = SettingManager.settings['level_op'].value
    if userLevel >= op:
        if not ent.isSet(adchpp.Entity.FLAG_OP):
            ent.setFlag(adchpp.Entity.FLAG_OP)
            change = True
    else:
        if ent.isSet(adchpp.Entity.FLAG_OP):
            ent.unsetFlag(adchpp.Entity.FLAG_OP)
            change = True

    su = SettingManager.settings['level_superuser'].value
    if userLevel >= su:
        if not ent.isSet(adchpp.Entity.FLAG_SU):
            ent.setFlag(adchpp.Entity.FLAG_SU)
            change = True
    else:
        if ent.isSet(adchpp.Entity.FLAG_SU):
            ent.unsetFlag(adchpp.Entity.FLAG_SU)
            change = True

    if str(ent.getField("NI")) == str(SettingManager.settings['owner'].value):
        if not ent.isSet(adchpp.Entity.FLAG_OWNER):
            ent.setFlag(adchpp.Entity.FLAG_OWNER)
            change = True
    else:
        if ent.isSet(adchpp.Entity.FLAG_OWNER):
            ent.unsetFlag(adchpp.Entity.FLAG_OWNER)
            change = True

    return change

def generateSalt():
    salt = bytearray()
    for i in range(32/4):
        r = adchpp.Util.rand()
        for j in range(4):
            salt.insert(i*4+j, (r>>(j*8))&0x000000FF)

    return salt

def registerUser(cid, nick, password, level, regby):
    usersLock.acquire()
    global users, nicks, cids, staticids, lastStaticid
    
    user = findUser(nick,cid)
    
    if not user:
        lastStaticid += 1
        user = User(nick=nick, cid=cid, password=password, level=level, staticid = lastStaticid, regby = regby, regtime = time.time(), lasttime = time.time())
        #user = User(nick=nick, cid=cid, level=level, staticid = lastStaticid, regby = regby, regtime = time.time(), lasttime = time.time())
        users.append(user)
    
    if cid:
        user.cid = cid

    th = adchpp.TigerHash()
    
    salt = generateSalt()
    th.update(password)
    th.update(str(salt))
        
    user.password = password #NO
    #user.passhash = autil.toUTF8(adchpp.Encoder.toBase32(str(th.finalize())))
    #user.salt = autil.toUTF8(adchpp.Encoder.toBase32(str(salt)))

    user.level = level
    
    if nick:
        nicks[nick] = user
    if cid:
        cids[cid] = user
    staticids[user.staticid] = user

    ent = Hub.ClientMgr.findByNick(str(user.nick))
    updateEntFlags(ent)

    saveUsers()
    usersLock.release()
    
    return user

def updateUser(user, cid, nick):
    usersLock.acquire()
    global nicks, cids
    nick = autil.toUTF8(nick)
    if user.nick != nick:
        if SettingManager.settings['allownickchange']['value'] == 0:
            usersLock.release()
            return False, "This hub doesn't allow registered users to change their nick; ask an operator to delete your current registration data if you really want a new nick. Please connect again with your current registered nick: " + str(user.nick)

        if nick in nicks:
            usersLock.release()
            return False, "Nick taken by another registered user"

        if user.nick:
            del(nicks[user.nick])

        user.nick = nick
        nicks[user.nick] = user
        saveUsers()
        usersLock.release()
        return True, "Registration data updated (new nick)"

    if user.cid != cid:
        if cid in cids:
            usersLock.release()
            return False, "CID taken by another registered user"

        if user.cid:
            del(cids[user.cid])
            user.cid = cid
            cids[user.cid] = user
            saveUsers()
            usersLock.release()
            return True, "Registration data updated (new CID)"

    usersLock.release()
    return True, None
