# -*- coding: iso-8859-15 -*-
import pyadchpp as adchpp
import Hub
from ScriptManager import ScriptBase
import autil
import re
import threading
import urllib
import urllib2
import time
import htmlentitydefs

def unescape(text):
    def fixup(m):
        text = m.group(0)
        if text[:2] == "&#":
            # character reference
            try:
                if text[:3] == "&#x":
                    return unichr(int(text[3:-1], 16))
                else:
                    return unichr(int(text[2:-1]))
            except ValueError:
                pass
        else:
            # named entity
            try:
                text = unichr(htmlentitydefs.name2codepoint[text[1:-1]])
            except KeyError:
                pass
        return text # leave as is

    return autil.toUTF8(re.sub("&#?\w+;", fixup, autil.toUTF8(text)))

def parseYoutube(url, pageData):
    if re.findall("watch\?v=", url)!=[]:
        title= re.findall(r'<\s*span[^>]*id\s*="eow-title"[^>]*title\s*=\s*"([^"]*)', pageData, re.I)[0]
        uploader = re.findall(r'<\s*a[^>]*class\s*="yt-user-name author"[^>]*>\s*([^<]*)<\s*/\s*a\s*>', pageData, re.I)[0]
        uploader = uploader.strip()
        length = re.findall(r"amp;length_seconds=([0-9]*)", pageData)[0]
        length = time.strftime("%M:%S", time.gmtime(int(length)))
        return "Video: %s by %s (%s)"%(title,uploader,length)
    else:
        title=re.findall("<\s*title\s*>(.*?)</title\s*>", pageData, re.I)[0]
        title = title.strip().strip("-").strip()
        domain = re.search("(?P<url>https?://[^/\s]+)", url).group("url")
        return "Title: %s (at %s)" % (title, domain)

def doNothing(url, pageData):
    return ""

def parseAdfly(url, pageData):
    realUrl = re.findall("var url = '(.*?)'",pageData)[0]
    Req = urllib2.Request(realUrl,None,{"User-Agent":"Mozilla/5.0 (X11; U; Linux i686) Gecko/20071127 Firefox/2.0.0.11"})
    response=urllib2.urlopen(Req,None, 15)
    page=response.read(50000)
    page=page.replace('\n','')
    fullURL=response.geturl()
    title=re.findall("<\s*title\s*>(.*?)</title\s*>", page, re.I)
    if len(title)>0:
        title=title[0]
        title=re.sub("\s\s+", " ", title).strip()
        domain = re.search("(?P<url>https?://[^/\s]+)", fullURL).group("url")
        return 'Title: ' + title + ' (at '+ domain +')'
    else:
        return 'PTarget URL: %s'%fullURL

URLMatch = re.compile(r"""(?i)\b((?:(?:[a-z][\w-]+:(?:/{1,3}|[a-z0-9%])|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}/)(?:[^\s()<>]+|\((?:[^\s()<>]+|(?:\(?:[^\s()<>]+\)))*\))+(?:\((?:[^\s()<>]+|(?:\([^\s()<>]+\)))*\)|[^\s`!()\[\]{};:'".,<>?])))""")


class Script(ScriptBase):
    def __init__(self):
        self.specialDomains={"https?://www.youtube.com":parseYoutube, "http://adf.ly":parseAdfly,
                             "https?://[^.]*.deviantart.com":doNothing, "https?://(?:[^.]?.)*fukung.net":doNothing}
        self.listener = autil.handleCommand(self.parse, adchpp.AdcCommand.CMD_MSG)

    def parse(self, ent, cmd, ok):
        if cmd.getCommand() != adchpp.AdcCommand.CMD_MSG or cmd.getType() != adchpp.AdcCommand.TYPE_BROADCAST:
            return True 

        if not ent:
            ent = Hub.ClientMgr.getEntity(cmd.getFrom())

        if not ent:
            return True

        urls = re.findall(URLMatch, str(cmd.getParam(0)) )

        if urls:
            urlFollowThread=threading.Thread(target=self.asyncUrlFollow, args=[urls])
            urlFollowThread.daemon = True
            urlFollowThread.start()

        return True

    def unload(self):
        del(self.listener)

    def reload(self):
        del(self.listener)
        self.listener = autil.handleCommand(self.parse, adchpp.AdcCommand.CMD_MSG)
        self.specialDomains={"https?://www.youtube.com":parseYoutube, "http://adf.ly":parseAdfly,
                             "https?://[^.]*.deviantart.com":doNothing, "https?://(?:[^.]?.)*fukung.net":doNothing}

    def getDomainMatch(self, domain):
        for key in self.specialDomains.keys():
            if re.match(key, domain)!=None:
                return key
        return False

    def asyncUrlFollow(self, urls):
        for url in urls:
            self.urlFollow(url)

    def urlFollow(self, url):
        if not re.match("(https?://[^/\s]+)", url):
            url = "http://" + url;
        
        try:
            try:
                #Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:10.0a1) Gecko/20111027 Firefox/10.0a1
                Req = urllib2.Request(url,None,{"User-Agent":"Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US; rv:1.9.2.23) Gecko/20110920 Firefox/3.6.23"})
                response=urllib2.urlopen(Req,None, 15)
                page=response.read(50000)
                page=page.replace('\n','')
                #page=unescape(page)
                fullURL=response.geturl()
                domain = re.search("(?P<url>https?://[^/\s]+)", url).group("url")         

            except Exception as detail:
                if str(detail)!="<urlopen error [Errno -2] Name or service not known>":
                    autil.hub_broadcast_ME("URLFollow Error: " + str(detail))
                    return
            
            if not self.getDomainMatch(domain):
                title=re.findall("<\s*title\s*>(.*?)</title\s*>", page, re.I)
                if len(title)>0:
                    title=title[0]
                    title=re.sub("\s\s+", " ", title).strip()
                    autil.hub_broadcast_ME(unescape('Title: ' + title + ' (at ' + domain +')'))
                    return
                else:
                    if url!=fullURL:
                        autil.hub_broadcast_ME(unescape('Target URL: %s'%fullURL))
                        return
            else:
                msg = self.specialDomains[self.getDomainMatch(domain)](url, page);
                if msg:
                    autil.hub_broadcast_ME(unescape(msg))
                return

        except Exception as detail:
            print("Exception:" + str(detail))
