import CommandManager
import pyadchpp as adchpp
import autil
import random
from ScriptManager import ScriptBase

class Script(ScriptBase):
    """description of class"""

    def __init__(self):
        random.seed()

        self.rollCmd = CommandManager.Command(key='roll', alias=['dice'],category="ScriptCommands",command=self.roll, helpTxt="[int] - Rolls 1-int, or if no parameter defaults to 1-100", user_command=
                                                  CommandManager.UserCommand(contexts=CommandManager.context_hub+CommandManager.context_userlist, path="Utility/Roll dice", hasPublic=True, command="roll " + CommandManager.createLine("Number of sides")))
        CommandManager.add(self.rollCmd)

    def unload(self):
        self.rollCmd.release()

    def reload(self):
        self.rollCmd.command = self.roll

    def roll(self, ent, cmd, params, public):
        diResult = 0
        diType = 100
        
        if params and len(params) == 1:
            diType = autil.toInt(params[0])

        if not diType or (params and len(params) > 1):
            autil.hub_reply(ent, "Roll command takes only 1 integer as a parameter, and must be greater than 0");
            return
     
        diResult = random.randint(1, diType)

        if public:
            autil.ent_reply(ent, "[d" + str(diType) + "] " + str(diResult));
        else:
            autil.hub_reply(ent, str(diResult));
