import Hub
import time
import sys, os, getopt

def handler(signum, frame):
    Hub.shutdownHub()

def run(configDir):
    import signal
    signal.signal(signal.SIGINT, handler)

    if Hub.initHub(configDir):
        Hub.startHub()
        while Hub.hubThread.is_alive():
            try:
                time.sleep(0.1)
            except Exception as err:
                pass

def showHelp():
    print("Usage: adchpp.py [[-c <configdir>] | [-v] | [-h]")

if __name__ == '__main__':
    helpOpt = False
    versionOpt = False
    configDir = "config"
    succeeded = False
    try:
        opts, args = getopt.getopt(sys.argv[1:], "hvc:")
        for opt, arg in opts:
            if opt == '-h':
                helpOpt = True
                break  
            if opt == '-v':
                versionOpt = True
                break            
            elif opt in '-c':
                configDir = arg
                if not os.path.isabs(configDir):
                    configDir = os.path.join(os.getcwd(),configDir)
                configDir = os.path.normpath(configDir)
                print(configDir)
                break

        succeeded = True

    except Exception as err:
        print(err)
        showHelp()

    if succeeded:
        if versionOpt:
            import pyadchpp
            print(pyadchpp.cvar.versionString)

        if helpOpt:
            showHelp()
        elif not helpOpt and configDir:
            if(os.path.exists(configDir)):
                run(configDir)
            else:
                print("The specified path doesn't exists")